# Generated by sila2.code_generator; sila2.__version__: 0.9.2

from typing import Optional
from uuid import UUID


from sila2.server import SilaServer

from .feature_implementations.cancelcontroller_impl import CancelControllerImpl
from .feature_implementations.connectionconfigurationservice_impl import ConnectionConfigurationServiceImpl
from .feature_implementations.dataaggregatorcontroller_impl import DataAggregatorControllerImpl
from .feature_implementations.influxdbcontroller_impl import InfluxDBControllerImpl
from .feature_implementations.measurementcontroller_impl import MeasurementControllerImpl
from .feature_implementations.pausecontroller_impl import PauseControllerImpl
from .feature_implementations.simulationcontroller_impl import SimulationControllerImpl
from .generated.cancelcontroller import CancelControllerFeature
from .generated.connectionconfigurationservice import ConnectionConfigurationServiceFeature
from .generated.dataaggregatorcontroller import DataAggregatorControllerFeature
from .generated.influxdbcontroller import InfluxDBControllerFeature
from .generated.measurementcontroller import MeasurementControllerFeature
from .generated.pausecontroller import PauseControllerFeature
from .generated.simulationcontroller import SimulationControllerFeature


class Server(SilaServer):
    def __init__(self, server_uuid: Optional[UUID] = None, 
                 simulation: bool = False,):
        # TODO: fill in your server information
        super().__init__(
            server_name="LabDataAggregator",
            server_type="DataAggregator",
            server_version="0.1",
            server_description="Generic Data Aggregator for SiLA2",
            server_vendor_url="https://lara.uni-greifswald.de",
            server_uuid=server_uuid,
        )

        self.cancelcontroller = CancelControllerImpl(self)
        self.set_feature_implementation(CancelControllerFeature, self.cancelcontroller)

        self.connectionconfigurationservice = ConnectionConfigurationServiceImpl(self)
        self.set_feature_implementation(ConnectionConfigurationServiceFeature, self.connectionconfigurationservice)

        self.dataaggregatorcontroller = DataAggregatorControllerImpl(self)
        self.set_feature_implementation(DataAggregatorControllerFeature, self.dataaggregatorcontroller)

        self.influxdbcontroller = InfluxDBControllerImpl(self)
        self.set_feature_implementation(InfluxDBControllerFeature, self.influxdbcontroller)

        self.pausecontroller = PauseControllerImpl(self)
        self.set_feature_implementation(PauseControllerFeature, self.pausecontroller)

        self.simulationcontroller = SimulationControllerImpl(self)
        self.set_feature_implementation(SimulationControllerFeature, self.simulationcontroller)

        self.measurementcontroller = MeasurementControllerImpl(self)
        self.set_feature_implementation(MeasurementControllerFeature, self.measurementcontroller)

        if simulation:
            self.simulationcontroller.StartSimulationMode()
